AWSTemplateFormatVersion: "2010-09-09"

Description: Download Center NAT Gateway Stack

Resources:
  # Stack name - ST-DW-NATGateway
  # 1 - Create EIP for NAT Gateway
  STDWNATGWEIP:
    Type: AWS::EC2::EIP
    Properties:
      Domain: !ImportValue STVPC

  # 2 - Create NAT Gateway
  STDWNATGateway:
    DependsOn: STDWNATGWEIP
    Type: AWS::EC2::NatGateway
    Properties:
      AllocationId:
        Fn::GetAtt:
          - STDWNATGWEIP
          - AllocationId
      SubnetId: !ImportValue STDWWebSubnetA

  # 3 - Create Route table for NAT Gateway
  STDWNATGWRouteTable:
    DependsOn: STDWNATGateway
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !ImportValue STVPC
      Tags:
        - Key: Name
          Value: st-dw-natgw-router

  # 4 - Create Route for NAT Gateway
  STDWNATGWRoute:
    DependsOn: STDWNATGWRouteTable
    Type: AWS::EC2::Route
    Properties:
      DestinationCidrBlock: 0.0.0.0/0
      NatGatewayId:
        Ref: STDWNATGateway
      RouteTableId:
        Ref: STDWNATGWRouteTable

  # 5 - Associate Route table with Private subnets
  # 5.1 - BL private subnet
  STDWBlSubnetANATGWRouteTableAssociate:
    DependsOn: STDWNATGWRoute
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      SubnetId: !ImportValue STDWBlSubnetA
      RouteTableId:
        Ref: STDWNATGWRouteTable

  # 5.2 - DB private subnet
  STDWDBSubnetANATGWRouteTableAssociate:
    DependsOn: STDWNATGWRoute
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      SubnetId: !ImportValue STDWDbSubnetA
      RouteTableId:
        Ref: STDWNATGWRouteTable

  # 5.3 - DOM private subnet
  STDWDOMSubnetANATGWRouteTableAssociate:
    DependsOn: STDWNATGWRoute
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      SubnetId: !ImportValue STDWDomSubnetA
      RouteTableId:
        Ref: STDWNATGWRouteTable
